package ${domain}.module.wsvr.mgr;

import ${domain}.frame.auth.Token;
import ${domain}.module.wsvr.req.ProfilesCreateRequest;
import ${domain}.module.wsvr.req.ProfilesDeleteRequest;
import ${domain}.module.wsvr.req.ProfilesFindRequest;
import ${domain}.module.wsvr.req.ProfilesUpdateRequest;
import ${domain}.module.wsvr.rsp.ProfilesCreateResponse;
import ${domain}.module.wsvr.rsp.ProfilesDeleteResponse;
import ${domain}.module.wsvr.rsp.ProfilesFindResponse;
import ${domain}.module.wsvr.rsp.ProfilesUpdateResponse;

/**
 * 系统配置
 *
 * @author wangbing
 * @version 0.0.1
 * @since 2020-07-06
 */
public interface ProfilesManager {

    /**
     * 插入
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    ProfilesCreateResponse create(ProfilesCreateRequest request, Token token);

    /**
     * 逻辑删除
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    ProfilesDeleteResponse delete(ProfilesDeleteRequest request, Token token);

    /**
     * 更新
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    ProfilesUpdateResponse update(ProfilesUpdateRequest request, Token token);

    /**
     * 查询
     *
     * @param request 请求对象
     * @param token   令牌
     * @return
     */
    ProfilesFindResponse find(ProfilesFindRequest request, Token token);

    /**
     * 获得当前环境配置
     *
     * @param key          键
     * @param defaultValue 默认值
     * @return
     */
    String getString(String key, String defaultValue);

    /**
     * 获得当前环境配置
     *
     * @param key          键
     * @param defaultValue 默认值
     * @return
     */
    int getInt(String key, int defaultValue);

    /**
     * 获得当前环境配置
     *
     * @param key          键
     * @param defaultValue 默认值
     * @return
     */
    long getLong(String key, long defaultValue);
}
